function [ lowdepthdata ] = genLowGaussian( high_depth, upscalefactor )
[row,col]=size(high_depth);
sampled_depth=zeros(row,col);
graphpos=zeros(row,col,2);
row_scale=upscalefactor;
col_scale=upscalefactor;
row_num=ceil(row/row_scale);
col_num=ceil(col/col_scale);
grid_scale=max(row_scale,col_scale);
grid_distribution=fspecial('gaussian',grid_scale,min(row_scale,col_scale)/6);
grid_distribution=grid_distribution(1+floor((grid_scale-row_scale)/2):grid_scale-ceil((grid_scale-row_scale)/2),1+floor((grid_scale-col_scale)/2):grid_scale-ceil((grid_scale-col_scale)/2));
grid_distribution=grid_distribution/sum(sum(grid_distribution));
grid_distribution=reshape(grid_distribution,[1 row_scale*col_scale]);
grid_distribution=cumsum(grid_distribution);
grid_distribution=reshape(grid_distribution,[row_scale,col_scale]);
low_depth=zeros(row_num,col_num);
low_depth_pos=zeros(row_num,col_num,2);
for i=1:1:row_num
    for j=1:1:col_num
        randindex=rand()+grid_distribution(1,1);
        [~,y_index]=find(grid_distribution<=randindex);
        y_index=max(y_index);
        [x_index]=find(grid_distribution(:,y_index)<=randindex);
        x_index=max(x_index);
        sampled_depth(min((i-1)*row_scale+x_index,row),min((j-1)*col_scale+y_index,col))=max(high_depth(min((i-1)*row_scale+x_index,row),min((j-1)*col_scale+y_index,col)),1e-3);
        low_depth(i,j)=max(high_depth(max(min((i-1)*row_scale+x_index,row),1),max(min((j-1)*col_scale+y_index,col),1)),1e-3);
        low_depth_pos(i,j,1)=max(min((i-1)*row_scale+x_index,row),1);
        low_depth_pos(i,j,2)=max(min((j-1)*col_scale+y_index,col),1);
        randindex=0.5;
        [~,y_index_graph]=find(grid_distribution<=randindex);
        y_index_graph=max(y_index_graph);
        [x_index_graph]=find(grid_distribution(:,y_index_graph)<=randindex);
        x_index_graph=max(x_index_graph);
        graphpos(min((i-1)*row_scale+x_index,row),min((j-1)*col_scale+y_index,col),1)=min((i-1)*row_scale+x_index_graph,row);
        graphpos(min((i-1)*row_scale+x_index,row),min((j-1)*col_scale+y_index,col),2)=min((j-1)*col_scale+y_index_graph,col);
    end
end
lowdepthdata.sampled_depth=sampled_depth;
lowdepthdata.low_depth=low_depth;
lowdepthdata.graphpos=graphpos;
lowdepthdata.low_depth_pos=low_depth_pos;

end


