function [ seg_image_final ] = genSegmentation( seg_tree, lowdepthdata, thresmulti )

sampled_depth = lowdepthdata.sampled_depth;
sampled_depth_pos = sampled_depth;
sampled_depth_pos(sampled_depth_pos>0) = 1;
low_depth = lowdepthdata.low_depth;
low_depth_pos = lowdepthdata.low_depth_pos;
[hrow,hcol] = size(sampled_depth);

% need to figure out the best thres value later
thresvalue = max(5/255*(max(max(low_depth))-min(min(low_depth))),5/255)*thresmulti;
fprintf('maxlow: %f, minlow: %f, thres: %f \n', max(max(low_depth)), min(min(low_depth)), thresvalue);

% record region that still need go down check
active_region = ones(size(sampled_depth))*size(seg_tree,3);
seg_image_final = zeros(hrow,hcol);
seg_count_final = 0;

is_sub_seg = false;
iter=0;
while iter < size(seg_tree,3)-1
    iter=iter+1;
    if is_sub_seg
        seg_image_cur = sub_seg_image;
    else
        seg_image_cur = seg_tree(:,:,iter);
    end
    seg_image = seg_tree(:,:,iter+1);
    sub_seg_image = seg_image_cur;
    is_sub_seg = false;
    for jter = 1:1:numel(unique(seg_image_cur))
        seg_node = zeros(hrow,hcol);
        seg_node(seg_image_cur==jter)=seg_image(seg_image_cur==jter);
        if sum(active_region(seg_node>0))>0
            if numel(unique(seg_node))>2
                seg_node_raw = seg_node;
                seg_node = seg_node.*sampled_depth_pos;
                [low_seg_node] = mapSegnode(seg_node,low_depth_pos);
                [leafstatus] = genSegleaf(low_seg_node,low_depth,thresvalue);
                if leafstatus.divstatus==0
                    active_region(seg_node_raw>0)=max(active_region(seg_node_raw>0)-1,0);
                end
                if leafstatus.divstatus==1
                    seg_count_final=seg_count_final+1;
                    seg_image_final(seg_node_raw>0)=seg_count_final;
                    active_region(seg_node_raw>0)=0;
                end
                if leafstatus.divstatus==2
                    is_sub_seg = true;
                    sub_seg_image(seg_node_raw==leafstatus.divseg)=max(max(sub_seg_image))+1;
                    active_region(seg_node_raw>0)=max(active_region(seg_node_raw>0)-1,0);
                end
            else
                active_region(seg_node>0)=max(active_region(seg_node>0)-1,0);
            end
        end
    end
    if is_sub_seg
        iter=iter-1;
        active_region(active_region>0)=active_region(active_region>0)+1;
    end
    
    one_active_region=zeros(size(sampled_depth));
    one_active_region(active_region==1)=1;
    if sum(sum(one_active_region))>0
        seg_node=seg_image.*active_region;
        seg_index=unique(seg_node);
        for i=2:1:numel(seg_index)
            seg_count_final=seg_count_final+1;
            seg_image_final(seg_node==seg_index(i))=seg_count_final;
        end
    end
end
fprintf('seg num: %f \n', seg_count_final);

seg_image_final_mix=seg_image_final;
[~,newind]=sort(rand(seg_count_final,1));
for i=1:1:seg_count_final
    seg_image_final_mix(seg_image_final==newind(i))=i;
end
[colordepth]=convertdepthcolor(((max(max(seg_image_final_mix))+1)-seg_image_final_mix)/(max(max(seg_image_final_mix))+1),1024);
imwrite(colordepth,'final.png','BitDepth',16);

end
