clear;
datasetnamelist={'Middlebury_small'};
datasetlist={'midsmall'};
smoothmethodlist={'simple','simple','advance','advance'};
samplemethodlist={'fix','gaussian','fix','gaussian'};

for outiter=1:1:numel(smoothmethodlist)
    smoothmethod=smoothmethodlist{outiter};
    samplemethod=samplemethodlist{outiter};
    for pipiter=1:1:numel(datasetnamelist)
        datasetname=datasetnamelist{pipiter};
        dataset=datasetlist{pipiter};
        
        [param]=setting_sdsr(dataset,smoothmethod,samplemethod);
        filenames={'image-090','image-100','image-110','image-120'};
        DIR=['./Data/',datasetname,'/'];
        
        fprintf('Dataset: %s \n', datasetname);
        fprintf('MinimumRegionArea: ');
        disp(param.MinimumRegionArea);
        fprintf('thresmulti: ');
        disp(param.thresmulti);
        
        for iter=1:1:numel(filenames)
            
            fprintf('Filename: %s \n', filenames{iter});
            filename=filenames{iter};
            rgbimage=imread([DIR,'image/',filename,'.png']);
            
            %% read and preprocess depth
            gtdepth=imread([DIR,'depth/',filename,'.png']);
            gtdepth=im2double(gtdepth);
            if numel(size(gtdepth))==3
                gtdepth=rgb2gray(gtdepth);
            end
            if param.isfillhole
                gtdepth=fillhole(gtdepth);
            end
            
            for upiter=1:1:numel(param.upscalefactor)
                
                fprintf('Upscale: %d \n', param.upscalefactor(upiter));
                %% generate low resolution samples
                if strcmp(param.samplemethod,'fix') || strcmp(param.samplemethod,'gaussian')
                    if strcmp(param.samplemethod,'fix')
                        [lowdepthdata]=genLowFix(gtdepth, param.upscalefactor(upiter));
                    end
                    if strcmp(param.samplemethod,'gaussian')
                        [lowdepthdata]=genLowGaussian(gtdepth, param.upscalefactor(upiter));
                    end
                else
                    disp('Please set sample method correctly. ');
                    exit;
                end
                
                %% generate segmentation
                [seg_tree]=segTree(rgbimage,param);
                [seg_image]=genSegmentation(seg_tree,lowdepthdata,param.thresmulti(upiter));
                
                %% generate super resolution depth
                [sr_result] = superResolution(lowdepthdata,seg_image,param,param.upscalefactor(upiter));
                imwrite(sr_result,['./Result/',datasetname,'/',filename,'_result_',smoothmethod,'_',samplemethod,'_',num2str(param.upscalefactor(upiter)),'.png']);
                
            end
            
        end
    end
end