function [param] = setting_sdsr(dataset,smoothmethod,samplemethod)
% Set all parameters here

param.upscalefactor = [8];
param.isfillhole = false;
param.isdenoise = false;
param.isexpanddetail = true;
param.segsource = 'EDISONlayer'; % 'EDISON', 'EDISONlayer', 'EDISONadvlayer'
param.smoothmethod = smoothmethod; % 'simple', 'advance'
param.samplemethod = samplemethod; % 'fix', 'gaussian'
param.dataformat = 'image'; % 'image', 'range'
param.dataset = dataset; % 'midsmall', 'nyu', 'mid', 'sintel','kinect'

% coarse correct
if strcmp(param.dataset,'midsmall')
% Setting 20150314
%     param.MinimumRegionArea=[800,400,200];
%     param.thresmulti=2*log(param.upscalefactor)/log(4);
    param.MinimumRegionArea=[800,400,200];
    param.thresmulti=2*log(param.upscalefactor).^1.5;
end
if strcmp(param.dataset,'nyu')
% Setting 20150314
%     param.MinimumRegionArea=[6400,3200,1600,800];
%     param.thresmulti=2*log(param.upscalefactor).^1.5/log(4);
    param.MinimumRegionArea=[6400,1600,800];
    param.thresmulti=2*log(param.upscalefactor).^1.5;
end
if strcmp(param.dataset,'mid')
% Setting 20150314
%     param.MinimumRegionArea=[6400,3200,1600,800];
%     param.thresmulti=2*log(param.upscalefactor)/log(4);
    param.MinimumRegionArea=[6400,1600,800];
    param.thresmulti=log(param.upscalefactor)/2;
end
if strcmp(param.dataset,'midnoise')
    param.MinimumRegionArea=[6400,1600,800];
    param.thresmulti=log(param.upscalefactor)/2;
end
if strcmp(param.dataset,'sintel')
% Setting 20150314
%     param.MinimumRegionArea=[6400,3200,1600,800];
%     param.thresmulti=2*log(param.upscalefactor)/log(4);
    param.MinimumRegionArea=[3200,400,200];
    param.thresmulti=log(param.upscalefactor);
end
% not adjusted
if strcmp(param.dataset,'kinect')
% Setting 20150314
%     param.MinimumRegionArea=[3200,1600,800,400];
%     param.thresmulti=2*log(param.upscalefactor)/log(4);
    param.MinimumRegionArea=[3200,1600,800,400];
    param.thresmulti=2*log(param.upscalefactor);
end

end
